#ifndef VEIH
#define VEIH

#include <tchar.h>
//---------------------------------------------------------------------------
#define	STR_MAX_LENGTH		512
#ifdef _UNICODE
	#define	FILENAME_MAX_LENGTH	256
#else
	#define	FILENAME_MAX_LENGTH	512
#endif


#define	FILE_MAX_STREAM_COUNT	10

enum {
	//t@C`

	//G[n
	FILETYPE_ERROR = 0,

	FILETYPE_UNKNOWN,			//Ή̃t@C
	FILETYPE_OPENFAILED,		//t@C̃I[vɎs

	//G[nI
	FILETYPE_ERROR_END,

	//Đ\Ȍ`
	FILETYPE_MEDIA = 10,

	//fƉ`
	FILETYPE_VIDEO_AUDIO,
	FILETYPE_AVI,				//RIFF AVI
	FILETYPE_MPEG1,				//MPEG1
	FILETYPE_MPEG1VCD,			//MPEG1(VideoCD)
	FILETYPE_QUICKTIME,			//QuickTime(ʂɎsMP4/3GPPn܂)
	FILETYPE_OGGMEDIA,			//ogg Media
	FILETYPE_MPEG2,				//MPEG2
	FILETYPE_MPEG2_TS,			//MPEG2-TS(188)
	FILETYPE_MPEG2_M2TS,		//MPEG2-TS(192)
	FILETYPE_WMV,				//WindowsMedia Video
	FILETYPE_REALMEDIA,			//RealMedia
	FILETYPE_3GPP,				//3GPP(QuickTime)
	FILETYPE_3GPP2,				//3GPP2(QuickTime)
	FILETYPE_MPEG4,				//MPEG4(QuickTime)
	FILETYPE_AMC,				//WIN܂łau̓
	FILETYPE_MATROSKA,			//Matroska
	FILETYPE_MPEG,				//MPEG?
	FILETYPE_FLV,

	//摜̌`(܂)
	FILETYPE_GRAPHIC = 50,

	FILETYPE_BMP,				//BMP
	FILETYPE_JPEG,				//JPEG/Exif
	FILETYPE_GIF,				//GIF

	//摜̌`I
	FILETYPE_GRAPHIC_END,

	//fƉ`I
	FILETYPE_VIDEO_AUDIO_END,

	//݂̂̌`
	FILETYPE_AUDIO = 100,

	FILETYPE_WAV,				//RIFF WAVE
	FILETYPE_MID,				//MIDI
	FILETYPE_RMI,				//RIFF MIDI
	FILETYPE_AU,				//Au
	FILETYPE_AIFF,				//AIFF
	FILETYPE_MP3,				//MP3(MPEG1`2.5 LayerI`III)
	FILETYPE_CDA,				//RIFF CDDA
	FILETYPE_RMP3,				//RIFF MP3
	FILETYPE_OGGVORBIS,			//ogg Vorbis
	FILETYPE_OGGSPEEX,			//ogg Speex
	FILETYPE_OGGFLAC,			//ogg Flac
	FILETYPE_WMA,				//WindowsMedia Audio
	FILETYPE_AC3,				//Dolby AC-3
	FILETYPE_MONKEY,			//Monkey's Audio
	FILETYPE_MUSEPACK,			//MusePack
	FILETYPE_FLAC,				//Flac
	FILETYPE_AAC,				//AAC(MPEG2/MPEG4)
	FILETYPE_REALAUDIO,			//RealMediaȑŐRealAudio
	FILETYPE_TTA,				//The True Audio
	FILETYPE_DTS14LE,			//DTS
	FILETYPE_DTS14BE,
	FILETYPE_DTS16LE,
	FILETYPE_DTS16BE,
	FILETYPE_WAVPACK,			//WavPack
	FILETYPE_OPTIMFROG,			//OptimFROG
	FILETYPE_VQ,				//TwinVQ
	FILETYPE_SHOCKWAVEMP3,		//ShockWave MP3
	FILETYPE_TAK,				//TAK

	//݂̂̌`I
	FILETYPE_AUDIO_END,

	//Đ\Ȍ`I
	FILETYPE_MEDIA_END,

	//ȉeXgp(F͂ĂȏtĂȂ)̌`
	FILETYPE_TEST = 200,

	FILETYPE_OPENMG_OMA,
	FILETYPE_PSF1,
	FILETYPE_PSF2,
	FILETYPE_SSF,
	FILETYPE_DSF,
	FILETYPE_USF,
	FILETYPE_QSF,

	//eXgp̌`I
	FILETYPE_TEST_END,

	//vCXg
	FILETYPE_PLAYLIST = 300,

	PLAYLIST_SHDKL,
	PLAYLIST_PLS,
	PLAYLIST_LST,
	PLAYLIST_ZPL,
	PLAYLIST_BSL,
	PLAYLIST_M3U,

	//vCXgI
	FILETYPE_PLAYLIST_END,
	FILETYPE_TEXT = 400
};

enum {
	MPEG2_DELAY_MSEC = 1,
	MPEG2_DELAY_PTS,

	MPEG2_DELAY_SAMPLE = 4,
	METASEEK = 8
};

typedef struct{
	_TCHAR				name[FILENAME_MAX_LENGTH];							//IN     : t@C
	int					type;								//IN/OUT : t@C
	char				container[32];						//OU     ;Rei
	char				error[2][STR_MAX_LENGTH];						//OUT    ;G[̓e(őQs)
	int					error_count;						//OUT    ;G[s
	char				comment[128];						//OUT    ;version̏ڍ(ʒut)
	char				video[FILE_MAX_STREAM_COUNT][STR_MAX_LENGTH];	//OUT    : f̏ڍ
	int					video_count;						//OUT    : f̏ڍׂ̐
	char				audio[FILE_MAX_STREAM_COUNT][STR_MAX_LENGTH];	//OUT    : ̏ڍ
	int					audio_count;						//OUT    : ̏ڍׂ̐
	char				creator[STR_MAX_LENGTH];						//OUT    : Ώۃt@C̏o/쐬Ɏgpꂽ\tg
	char				extra[FILE_MAX_STREAM_COUNT][STR_MAX_LENGTH];	//OUT    : t
	int					extra_count;						//OUT    : t̐
	double				playtime;							//OUT    : Đ(b)
	unsigned long int	option_sw;							//IN     : MPEG2͎̃IvVw
	unsigned long int	readsize_start;						//IN     : t@C擪̍őǂݍ݃TCY
	unsigned __int64	tail_location;						//IN     : t@Cǂݍލۂ̊JnItZbg
	unsigned __int64	size;								//OUT    : t@CTCY
}FILE_INFO;

typedef struct {
	int		version;
	void	(__stdcall *Init )( void );
	void	(__stdcall *InitFree )( void );
	int		(__stdcall *GetDllVersion )( void );
	void	(__stdcall *GetFileFormat )(  FILE_INFO *FI );
	void	(__stdcall *SetPath )( wchar_t *path );
	void	(__stdcall *ReFormFull )( FILE_INFO *FI, char *str );
	void	(__stdcall *GetDllComment)( FILE_INFO *FI );
	void	(__stdcall *GetInfo )( FILE_INFO *FI );
	int		(__stdcall *Unicode )( void );
}veiFunc;


//---------------------------------------------------------------------------


#endif
