unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,shellapi,vei,strutils;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    select: TRadioGroup;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    GroupBox1: TGroupBox;
    cboxWavpackmd5: TCheckBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure WMDropFiles(Var Msg: TMsg); Message WM_DROPFILES ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

  GetInfo: procedure(var FI: FileInfo); stdcall;
  ReFormFull: procedure(var FI: FileInfo;var buf: array of ansichar);stdcall;
  GetFileFormat: procedure(var FI: FileInfo); stdcall;
  GetDllVersion: function: cardinal;stdcall;
  SetPath: procedure(var pt: array of char); stdcall;
  GetDllComment: procedure(var FI: FileInfo); stdcall;
  Unicode: function: cardinal;stdcall;

implementation

{$R *.dfm}

function backslash(f: string): string;
begin
result:=f;
if rightstr(f,1)<>'\' then result:=result+'\';
end;



procedure TForm1.WMDropFiles(Var Msg: TMsg);
Var
FileName: array[0..MAX_PATH] of Char;
pt: array[0..511] of char;
FI: FileInfo;
buf: array[0..1023] of ansichar;
str,fn: string;
hDLL:THandle;
vchk: cardinal;
ptstr: string;
begin
memo1.Lines.Clear;
DragQueryFile(Msg.message, 0, FileName, SizeOf(FileName));

 fn:=FileName;
//t@C̓f[^
DragFinish(Msg.message);


hDLL:= LoadLibrary('vei.dll');
if hDLL = 0 then
 begin
   showmessage('vei.dll܂');
   application.Terminate;
   exit;
 end;

@GetDllVersion := GetProcAddress(hDLL, 'GetDllVersion');
if @GetDllVersion=nil then
 begin
  showmessage('GetDllVersion֐̃AhXs');
  application.Terminate;
 end;
@GetInfo:=GetProcAddress(hDLL, 'GetInfo');
if @GetInfo=nil then
 begin
  showmessage('GetInfo֐̃AhXs');
  application.Terminate;
 end;
@ReFormFull:=GetProcAddress(hDLL, 'ReFormFull');
if @ReFormFull=nil then
 begin
  showmessage('ReFormFull֐̃AhXs');
  application.Terminate;
 end;
@GetFileFormat:=GetProcAddress(hDLL, 'GetFileFormat');
if @GetFileFormat=nil then
 begin
  showmessage('GetFileFormat֐̃AhXs');
  application.Terminate;
 end;
@SetPath:=GetProcAddress(hDLL, 'SetPath');
if @SetPath=nil then
 begin
  showmessage('SetPath֐̃AhXs');
  application.Terminate;
 end;
@GetDllComment:=GetProcAddress(hDLL, 'GetDllComment');
if @GetDllComment=nil then
 begin
  showmessage('GetDllComment֐̃AhXs');
  application.Terminate;
 end;
@Unicode:=GetProcAddress(hDLL, 'Unicode');
if @Unicode=nil then
 begin
  showmessage('Unicode֐̃AhXs');
  application.Terminate;
 end;

if Unicode=0 then
 begin
  ShowMessage('Ansił͂܂');

 end;

//o[W擾
vchk:=GetDllVersion;
if vchk<070000 then
 begin
  ShowMessage('o[W(06xxxx)ɂ͑ΉĂ܂');
  freelibrary(hDLL);
  application.Terminate;
  exit;
 end;

//INIt@C̃pXݒ
ptstr:=backslash(extractfilepath(application.exename));
zeromemory(@pt[0],512);
copymemory(@pt[0],pchar(ptstr),256);
SetPath(pt);

str:='';
zeromemory(@FI,sizeof(FI));
copymemory(@FI.name,pchar(fn),512);

str:='['+ExtractFileName(FI.name)+']'+#13#10;

if form1.RadioGroup1.ItemIndex=0 then FI.option_sw:=MPEG2_DELAY_MSEC;
if form1.checkbox1.checked then FI.option_sw:=FI.option_sw or MPEG2_DELAY_PTS;
if form1.checkbox2.checked then FI.option_sw:=FI.option_sw or MPEG2_DELAY_SAMPLE;
if form1.cboxWavpackmd5.Checked then FI.option_sw:=FI.option_sw or METASEEK;

if form1.Select.itemindex=0 then
 begin
  GetFileFormat(FI);
  memo1.Lines.Add('FileFormat='+IntToStr(FI.ftype));
  freelibrary(hDLL);
  exit;
 end;

//ڍ׎擾
GetInfo(FI);
zeromemory(@buf[0],sizeof(buf));
ReFormFull(FI,buf);

if FI.ftype=FILETYPE_OPENFAILED then
 begin
  strcopy(@buf[0],pchar('['+extractfilename(FI.name)+']'+#13#10+'t@CI[vG['+#13#10+#13#10));
 end;
str:=str+buf+#13#10;

GetDllComment(FI);
str:=str+format('%s / DLL %.06d%s',[form1.Caption,GetDllVersion,FI.comment])+#13#10;
form1.memo1.Lines.add(str);
freelibrary(hDLL);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//t@Chbv󂯎悤ɐݒ肷
DragAcceptFiles(Form1.Handle, True);

end;


end.
