//---------------------------------------------------------------------------

#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

#include "vei.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

veiFunc	vei;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	DragAcceptFiles(Handle, True); //hbO&hbvLɂ
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ReceiveDropFiles(TWMDropFiles Message)
{

	HINSTANCE hDLL;
	FILE_INFO	FI;
	char		buf[1024];
	char		message[2048];
	TCHAR 		ptstr[512];
	int i;

	memset( message, 0, sizeof( message ));
	Memo1->Lines->Clear();
	hDLL = LoadLibrary( _T("vei.dll") );
	if( hDLL == NULL )
	{
		ShowMessage( "vei.dll[hł܂ł" );
		exit( 1 );
	}

	//֐ւ̃|C^

	*( int  ** )&vei.GetDllVersion	= ( int  * )GetProcAddress( hDLL, "GetDllVersion" );
	*( void ** )&vei.GetDllComment	= ( void  * )GetProcAddress( hDLL, "GetDllComment" );
	*( void ** )&vei.GetFileFormat	= ( void * )GetProcAddress( hDLL, "GetFileFormat" );
	*( void ** )&vei.GetInfo		= ( void * )GetProcAddress( hDLL, "GetInfo" );
	*( void ** )&vei.ReFormFull		= ( void * )GetProcAddress( hDLL, "ReFormFull" );
	*( void ** )&vei.SetPath		= ( void * )GetProcAddress( hDLL, "SetPath" );
	*( int  ** )&vei.Unicode	= ( int  * )GetProcAddress( hDLL, "Unicode" );


	if( vei.GetDllVersion == NULL )
	{
		ShowMessage( "DLL̊֐̃AhX܂" );
		FreeLibrary( hDLL );
		return;
	}
	if( vei.Unicode == NULL )
	{
		ShowMessage( "ANSIDLL͎g܂(DLL)" );
		FreeLibrary( hDLL );
		return;
	}
	if( vei.Unicode() != 1 )
	{
		ShowMessage( "ANSIDLL͎g܂(=0)" );
		FreeLibrary( hDLL );
		return;
	}


	//o[Wԍ擾
	vei.version = vei.GetDllVersion();

	//INIt@C̃pXݒ
	memset(ptstr,0,512);
	_tcscpy(ptstr,ExtractFilePath(Application->ExeName).c_str());
	vei.SetPath(ptstr);

	const int NameMax = 1024;
	TCHAR FileName[NameMax + 10];
	DragQueryFile((HDROP)Message.Drop, 0, FileName, NameMax);

	memset( &FI, 0, sizeof( FILE_INFO ));
	_tcscpy( FI.name, FileName);

	DragFinish((HDROP)Message.Drop);

	//MPEG2̃IvV
	if (RadioGroup1->ItemIndex==1)
	{
		FI.option_sw=MPEG2_DELAY_MSEC;
	}
	if (CheckBox1->Checked)
	{
		FI.option_sw|=MPEG2_DELAY_PTS;
	}
	if (CheckBox2->Checked)
	{
		FI.option_sw|=MPEG2_DELAY_SAMPLE;
	}
	if (cboxWavpackmd5->Checked )
	{
		FI.option_sw=METASEEK;
	}

	if (select->ItemIndex==0)
	{//t@CtH[}bg̎s͂B
		vei.GetFileFormat( &FI );
		memset( buf, 0, sizeof( buf ));
		sprintf( buf,"FileFormat %d",FI.type);
		Memo1->Lines->Add(  buf );
		FreeLibrary( hDLL );
		return;
	}

	//ڍ׎擾
	vei.GetInfo( &FI );

	memset( buf, 0, sizeof( buf ));
	//ʂttH[ɕϊ
	vei.ReFormFull( &FI,buf );
	Memo1->Lines->Add("["+ExtractFileName(FI.name)+"]");

	Memo1->Lines->Add( buf );

	vei.GetDllComment(&FI);
	sprintf( message ,"video easy info DLL %.6d %s %s",vei.version,(vei.Unicode()==1) ? "Unicode" : "ANSI", FI.comment);
	Memo1->Lines->Add( message );

	FreeLibrary( hDLL );
}

